// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com


package engine.objects;

import engine.Enum;
import engine.InterestManagement.WorldGrid;
import engine.gameManager.*;
import engine.net.ByteBufferWriter;
import engine.net.client.msg.ErrorPopupMsg;
import engine.server.MBServerStatics;
import engine.workthreads.ZergMechanicThread;
import org.pmw.tinylog.Logger;

import java.net.UnknownHostException;
import java.nio.charset.StandardCharsets;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDateTime;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

import static engine.gameManager.DbManager.MineQueries;
import static engine.gameManager.DbManager.getObject;
import static engine.math.FastMath.sqr;

public class Mine extends AbstractGameObject {

    public static ConcurrentHashMap<Mine, Integer> mineMap = new ConcurrentHashMap<>(MBServerStatics.CHM_INIT_CAP, MBServerStatics.CHM_LOAD, MBServerStatics.CHM_THREAD_LOW);
    public static ConcurrentHashMap<Integer, Mine> towerMap = new ConcurrentHashMap<>(MBServerStatics.CHM_INIT_CAP, MBServerStatics.CHM_LOAD, MBServerStatics.CHM_THREAD_LOW);
    private String zoneName;
    private Zone parentZone;
    public boolean isActive = false;
    public PlayerCharacter lastClaimer;
    public boolean wasClaimed = false;
    // Not persisted to DB
    public String guildName;
    public GuildTag guildTag;
    public String nationName;
    public GuildTag nationTag;
    private Resource production;
    private Guild owningGuild;
    private int flags;
    private int buildingID;
    private MineProduction mineType;

    public int capSize;

    public final HashSet<Integer> _playerMemory = new HashSet<>();
    public final HashMap<Integer,Long> _recentMemory = new HashMap<>();
    public HashMap<Guild,ArrayList<Integer>> dividedPlayers;

    public boolean hasProduced = false;

    public int liveHour;
    public int liveMinute;
    public Boolean firstThirty = true;

    public static ArrayList<Mine> ChinaMines = new ArrayList<>();
    public static ArrayList<Mine> EuroMines = new ArrayList<>();
    public static ArrayList<Mine> AmericaMines = new ArrayList<>();

    public boolean wasOpened = false;
    /**
     * ResultSet Constructor
     */
    public Mine(ResultSet rs) throws SQLException, UnknownHostException {
        super(rs);

        this.mineType = MineProduction.getByName(rs.getString("mine_type"));
        //this.mineType = MineProduction.LUMBER;

        int ownerUID = rs.getInt("mine_ownerUID");
        this.buildingID = rs.getInt("mine_buildingUID");
        this.flags = rs.getInt("flags");
        //int parent = rs.getInt("parent");
        if(BuildingManager.getBuildingFromCache(rs.getInt("mine_buildingUID")) != null) {
            Building tower = BuildingManager.getBuildingFromCache(rs.getInt("mine_buildingUID"));

            for (Zone zone : ZoneManager.getAllZonesIn(tower.loc)) {
                if (zone.isMacroZone()) {
                    this.parentZone = zone;
                    this.zoneName = this.parentZone.getParent().getName();
                }
            }

            this.owningGuild = Guild.getGuild(ownerUID);
            Guild nation = null;

            if (this.owningGuild.isEmptyGuild()) {
                this.guildName = "";
                this.guildTag = GuildTag.ERRANT;
                nation = Guild.getErrantGuild();
                this.owningGuild = Guild.getErrantGuild();
            } else {
                this.guildName = this.owningGuild.getName();
                this.guildTag = this.owningGuild.getGuildTag();
                nation = this.owningGuild.getNation();
            }

            if (!nation.isEmptyGuild()) {
                this.nationName = nation.getName();
                this.nationTag = nation.getGuildTag();
            } else {
                this.nationName = "";
                this.nationTag = GuildTag.ERRANT;
            }

            this.production = Resource.valueOf(rs.getString("mine_resource"));
            this.lastClaimer = null;
            this.liveHour = rs.getInt("mineLiveHour");
            this.liveMinute = rs.getInt("mineLiveMinute");
            this.capSize = rs.getInt("capSize");

            if(BuildingManager.getBuilding(this.buildingID) != null) {
                Building mineTower = BuildingManager.getBuilding(this.buildingID);
                if (mineTower != null) {
                    mineTower.setMaxHitPoints(5000 * this.capSize);
                    mineTower.setCurrentHitPoints((float) 5000 * this.capSize);
                }
            }
        }
    }

    public static void releaseMineClaims(PlayerCharacter playerCharacter) {

        if (playerCharacter == null)
            return;

        for (Mine mine : Mine.getMines()) {

            if (mine.lastClaimer != null)
                if (mine.lastClaimer.equals(playerCharacter)) {
                    mine.lastClaimer = null;
                    mine.updateGuildOwner(null);
                }

        }
    }

    public static void SendMineAttackMessage(Building mine) {

        if (mine.getBlueprint() == null)
            return;

        if (mine.getBlueprint().getBuildingGroup() != Enum.BuildingGroup.MINE)
            return;


        if (mine.getGuild().isEmptyGuild())
            return;

        if (mine.getGuild().getNation().isEmptyGuild())
            return;

        if (mine.getTimeStamp("MineAttack") > System.currentTimeMillis())
            return;

        mine.getTimestamps().put("MineAttack", System.currentTimeMillis() + MBServerStatics.ONE_MINUTE);

        ChatManager.chatNationInfo(mine.getGuild().getNation(), mine.getName() + " in " + mine.getParentZone().getParent().getName() + " is Under attack!");
    }

    public static void loadAllMines() {

        try {

            //Load mine resources
            MineProduction.addResources();

            //pre-load all building sets
            ArrayList<Mine> serverMines = MineQueries.GET_ALL_MINES_FOR_SERVER();

            for (Mine mine : serverMines) {
                Mine.mineMap.put(mine, mine.buildingID);
                Mine.towerMap.put(mine.buildingID, mine);
                //mine.mineType = MineProduction.LUMBER;
            }

        }catch(Exception e) {

        }
    }

    /*
     * Getters
     */

    public static Mine getMineFromTower(int towerID) {
        return Mine.towerMap.get(towerID);
    }

    public static String getMineNationality(int time){
        switch(time){
            case 7:
            case 8:
            case 9:
                return "CN";
            case 14:
            case 15:
            case 16:
                return "EU";
            case 20:
            case 21:
            case 22:
                return "NA";
            default:
                return "Unknown";
        }
    }
    public static void serializeForClientMsg(Mine mine, ByteBufferWriter writer) {
        writer.putInt(mine.getObjectType().ordinal());
        writer.putInt(mine.getObjectUUID());
        writer.putInt(mine.getObjectUUID()); //actually a hash of mine
        writer.putString(mine.mineType.name);
        writer.putString(Mine.getMineNationality(mine.liveHour) + " " + mine.capSize + " Man ");
        writer.putInt(mine.production.hash);
        writer.putInt(mine.getModifiedProductionAmount());
        writer.putInt(mine.getModifiedProductionAmount()); //TODO calculate range penalty here
        writer.putInt(3600); //window in seconds //production per hour in seconds?

        // Errant mines are currently open.  Set time to now.

        LocalDateTime mineOpenTime = LocalDateTime.now().withHour(mine.liveHour).withMinute(mine.liveMinute);

        LocalDateTime mineCloseTime = mineOpenTime.plusMinutes(30);
        if(LocalDateTime.now().isAfter(mineCloseTime) && mine.isActive == false){
            mineOpenTime = mineOpenTime.plusDays(1);
            mineCloseTime = mineCloseTime.plusDays(1);
        }
        writer.putLocalDateTime(mineOpenTime);
        writer.putLocalDateTime(mineCloseTime);

        writer.put(mine.isActive ? (byte) 0x01 : (byte) 0x00);

        Building mineTower = BuildingManager.getBuilding(mine.buildingID);
        writer.putFloat(mineTower.getLoc().x);
        writer.putFloat(mineTower.getParentZone().getLoc().y);
        writer.putFloat(mineTower.getLoc().z);

        writer.putInt(mine.isExpansion() ? mine.mineType.xpacHash : mine.mineType.hash);

        writer.putString(mine.nationName);
        GuildTag._serializeForDisplay(mine.guildTag, writer);

        boolean isPM = false;
        if(mineOpenTime.getHour() > 11)
            isPM = true;

        int hourOpen = mineOpenTime.getHour();
        int minuteOpen = mineOpenTime.getMinute();
        int hourClose = mineCloseTime.getHour();
        int minuteClose = mineCloseTime.getMinute();

        if(isPM){
            hourOpen -= 12;
            hourClose -= 12;
        }
        String timeString = hourOpen + ":";
        if(minuteOpen == 0){
            timeString += "00 ";
        }else{
            timeString += "30 ";
        }

        if(isPM){
            timeString += "PM ";
        }else{
            timeString += "AM ";
        }

        timeString += " to ";

        timeString += hourClose + ":";

        if(minuteClose == 0){
            timeString += "00 ";
        }else{
            timeString += "30 ";
        }

        if(isPM){
            timeString += "PM CST";
        }else{
            timeString += "AM CST";
        }
        writer.putString(timeString);
        GuildTag._serializeForDisplay(mine.nationTag, writer);
    }

    public static ArrayList<Mine> getMinesForGuild(int guildID) {

        ArrayList<Mine> mineList = new ArrayList<>();

        // Only inactive mines are returned.

        for (Mine mine : Mine.mineMap.keySet()) {
            if (mine.owningGuild.getObjectUUID() == guildID &&
                    mine.isActive == false)
                mineList.add(mine);
        }
        return mineList;
    }

    /*
     * Database
     */
    public static Mine getMine(int UID) {
        return MineQueries.GET_MINE(UID);

    }

    public static ArrayList<Mine> getMines() {
        return new ArrayList<>(mineMap.keySet());
    }

    public static boolean validateClaimer(PlayerCharacter playerCharacter) {

        // Method validates that the claimer meets
        // all the requirements to claim; landed
        // guild with a warehouse, etc.

        Guild playerGuild;

        //verify the player exists

        if (playerCharacter == null)
            return false;

        //verify the player is in valid guild

        playerGuild = playerCharacter.getGuild();

        // Can't claim something if you don't have a guild!

        if (playerGuild.isEmptyGuild())
            return false;

        if (playerGuild.getNation().isEmptyGuild())
            return false;

        // Guild must own a city to hold a mine.

        City guildCity = playerGuild.getOwnedCity();

        if (guildCity == null)
            return false;

        if (guildCity.getWarehouse() == null) {
            ErrorPopupMsg.sendErrorMsg(playerCharacter, "No Warehouse exists for this claim.");
            return false;
        }

        // Number of mines is based on the rank of the nation's tree.

        City nationCapitol = playerGuild.getNation().getOwnedCity();

        Building nationCapitolTOL = nationCapitol.getTOL();

        if (nationCapitolTOL == null)
            return false;

        //int treeRank = nationCapitolTOL.getRank();

        //if (treeRank < 1)
        //    return false;

        //if (guildUnderMineLimit(playerGuild.getNation(), treeRank) == false) {
        //    ErrorPopupMsg.sendErrorMsg(playerCharacter, "Your nation cannot support another mine.");
        //    return false;
        //}

        return true;
    }

    private static boolean guildUnderMineLimit(Guild playerGuild, int tolRank) {

        int mineCnt = 0;

        mineCnt += Mine.getMinesForGuild(playerGuild.getObjectUUID()).size();

        for (Guild guild : playerGuild.getSubGuildList())
            mineCnt += Mine.getMinesForGuild(guild.getObjectUUID()).size();

        return mineCnt <= tolRank;
    }

    public boolean changeProductionType(Resource resource) {
        //if (!this.validForMine(resource))
        //    return false;
        //update resource in database;
        if (!MineQueries.CHANGE_RESOURCE(this, resource))
            return false;

        if(this.isActive || this.hasProduced)
            return false;

        this.production = resource;
        this.hasProduced = true;
        ItemBase resourceIB = ItemBase.getItemBase(this.production.UUID);

        return this.owningGuild.getOwnedCity().getWarehouse().depositFromMine(this, resourceIB, this.getModifiedProductionAmount());
    }

    public MineProduction getMineType() {
        return this.mineType;
    }

    public void setMineType(String type) {
        this.mineType = MineProduction.getByName(type);
    }

    public String getZoneName() {
        return this.zoneName;
    }

    public Resource getProduction() {
        return this.production;
    }

    public boolean getIsActive() {
        return this.isActive;
    }

    public Guild getOwningGuild() {
        if (this.owningGuild == null)
            return Guild.getErrantGuild();
        else
            return this.owningGuild;
    }

    public void setOwningGuild(Guild owningGuild) {
        this.owningGuild = owningGuild;
    }

    /*
     * Serialization
     */

    public int getFlags() {
        return flags;
    }

    public void setFlags(int flags) {
        this.flags = flags;
    }

    public Zone getParentZone() {
        return parentZone;
    }

    public GuildTag getGuildTag() {
        return guildTag;
    }

    public void setActive(boolean isAc) {

        this.isActive = isAc;
        Building building = BuildingManager.getBuildingFromCache(this.buildingID);
        if (building != null && !this.isActive)
            building.isDeranking.compareAndSet(true, false);

        if(isAc) {
            ZergMechanicThread.startZergThreadMine(this);
        }

        this.wasOpened = true;
    }

    public boolean validForMine(Resource r) {
        if (this.mineType == null)
            return false;
        return this.mineType.validForMine(r, this.isExpansion());
    }

    public void serializeForMineProduction(ByteBufferWriter writer) {
        writer.putInt(this.getObjectType().ordinal());
        writer.putInt(this.getObjectUUID());
        writer.putInt(this.getObjectUUID()); //actually a hash of mine
        //		writer.putInt(0x215C92BB); //this.unknown1);
        writer.putString(this.mineType.name);
        writer.putString(this.zoneName);
        writer.putInt(this.production.hash);
        writer.putInt(this.production.baseProduction);
        writer.putInt(this.getModifiedProductionAmount()); //TODO calculate range penalty here
        writer.putInt(3600); //window in seconds
        writer.putInt(this.isExpansion() ? this.mineType.xpacHash : this.mineType.hash);
    }

    @Override
    public void updateDatabase() {
        // TODO Create update logic.
    }

    public int getBuildingID() {
        return buildingID;
    }

    public void setBuildingID(int buildingID) {
        this.buildingID = buildingID;
    }

    public void handleDestroyMine() {

        if (!this.isActive)
            return;

        //remove tags from mine

        this.guildName = "";
        this.nationName = "";
        this.owningGuild = Guild.getErrantGuild();
        this.lastClaimer = null;
        this.wasClaimed = false;
        this.hasProduced = false;
        // Update database

        DbManager.MineQueries.CHANGE_OWNER(this, 0);

        // Update mesh

        Building mineBuilding = BuildingManager.getBuildingFromCache(this.buildingID);

        if (mineBuilding == null) {
            Logger.debug("Null mine building " + this.getObjectUUID() + ". Unable to Load Building with UID " + this.buildingID);
            return;
        }

        mineBuilding.setOwner(null);
        mineBuilding.refresh(false);

        // remove hirelings

        Building building = (Building) getObject(Enum.GameObjectType.Building, this.buildingID);
        BuildingManager.cleanupHirelings(building);
    }

    public boolean claimMine(PlayerCharacter claimer) {

        if (claimer == null)
            return false;

        if (!validateClaimer(claimer))
            return false;

        if (!this.isActive) {
            ErrorPopupMsg.sendErrorMsg(claimer, "Can not for to claim inactive mine.");
            return false;
        }

        if (!updateGuildOwner(claimer))
            return false;

        // Successful claim

        this.lastClaimer = claimer;

        return true;
    }

    public boolean depositMineResources() {

        if (this.owningGuild.isEmptyGuild())
            return false;

        if (this.owningGuild.getOwnedCity() == null)
            return false;

        if (this.owningGuild.getOwnedCity().getWarehouse() == null)
            return false;

        ItemBase resourceIB = ItemBase.getItemBase(this.production.UUID);
        return this.owningGuild.getOwnedCity().getWarehouse().depositFromMine(this, resourceIB, this.getModifiedProductionAmount());
    }

    public boolean updateGuildOwner(PlayerCharacter playerCharacter) {

        Building mineBuilding = BuildingManager.getBuildingFromCache(this.buildingID);

        //should never return null, but let's check just in case.

        if (mineBuilding == null) {
            ChatManager.chatSystemError(playerCharacter, "Unable to find mine tower.");
            Logger.debug("Failed to Update Mine with UID " + this.getObjectUUID() + ". Unable to Load Building with UID " + this.buildingID);
            return false;
        }

        if (playerCharacter == null) {
            this.owningGuild = Guild.getErrantGuild();
            this.guildName = "None";
            this.guildTag = GuildTag.ERRANT;
            this.nationName = "None";
            this.nationTag = GuildTag.ERRANT;
            //Update Building.
            mineBuilding.setOwner(null);
            WorldGrid.updateObject(mineBuilding);
            return true;
        }

        Guild guild = playerCharacter.getGuild();

        if (guild.getOwnedCity() == null)
            return false;

        if (!MineQueries.CHANGE_OWNER(this, guild.getObjectUUID())) {
            Logger.debug("Database failed to Change Ownership of Mine with UID " + this.getObjectUUID());
            ChatManager.chatSystemError(playerCharacter, "Failed to claim Mine.");
            return false;
        }

        //update mine.
        this.owningGuild = guild;

        //Update Building.
        PlayerCharacter guildLeader = (PlayerCharacter) Guild.GetGL(this.owningGuild);

        if (guildLeader != null)
            mineBuilding.setOwner(guildLeader);
        WorldGrid.updateObject(mineBuilding);
        return true;
    }

    public boolean isExpansion() {
        return true;
    }

    public int getModifiedProductionAmount() {
        int value = Warehouse.getCostForResource(this.production.UUID);
        int amount = 0;
        switch(this.capSize){
            case 3:
                amount = 1800000;
                break;
            case 5:
                amount = 3000000;
                break;
            case 10:
                amount = 6000000;
                break;
            case 20:
                amount = 12000000;
                break;
        }
        if(this.production.UUID == 7)
            amount *= 0.5f;
        else
            amount = amount / value;
        return (int) amount;
    }
    public Boolean onExit(HashSet<AbstractWorldObject> currentPlayers){
        ArrayList<Integer> purge = new ArrayList<>();
        for(int id : this._playerMemory){
            PlayerCharacter player = PlayerCharacter.getPlayerCharacter(id);
            if(!currentPlayers.contains(player)){
                purge.add(id);
                player.ZergMultiplier = 1.0f;
                //ChatManager.chatSystemInfo(player,"Left Mine, Multiplier: " + player.ZergMultiplier);
            }
        }

        if(purge.size() > 0) {
            //this._playerMemory.removeAll(purge);
            for(int id : purge){
                if(!this._recentMemory.containsKey(id)) {
                    this._recentMemory.put(id, System.currentTimeMillis() + 60000);
                } else if(this._recentMemory.get(id) > System.currentTimeMillis()){
                    this._playerMemory.remove(id);
                    //ChatManager.chatSystemInfo(PlayerCharacter.getPlayerCharacter(id),"Left Have Been Removed from The Mine List");
                }
            }
        }
        return true;
    }
}
